<?php
class Quivers_Integration_Model_ValidationObserver
{
	public function validateBillingAddress($observer)
    {
    	$data = $observer->getEvent()->getControllerAction()->getRequest()->getPost('billing', array());
        $country_id = $data['country_id'];
        $postcode = $data['postcode'];
        $telephone = $data['telephone'];
        if ($country_id == 'US') {
        	$validation = "/^[0-9]{5}(?:-[0-9]{4})?$/";
        	if (!preg_match($validation, $postcode)) {
        		$controller = $observer->getControllerAction();
		        $controller->setFlag('', Mage_Core_Controller_Varien_Action::FLAG_NO_DISPATCH, true);
		        $result = array('error' => 1, 'message' => Mage::helper('checkout')->__('Please enter a valid Zip/Postal Code.'));
		        $controller->getResponse()->setBody(Mage::helper('core')->jsonEncode($result));
		        return;
	        }
        } else {
        	$validation = "/^[a-zA-Z0-9 ]+$/";
        	if (!preg_match($validation, $postcode)) {
        		$controller = $observer->getControllerAction();
		        $controller->setFlag('', Mage_Core_Controller_Varien_Action::FLAG_NO_DISPATCH, true);
		        $result = array('error' => 1, 'message' => Mage::helper('checkout')->__('Please use only letters (a-z or A-Z), numbers (0-9) or spaces only for Zip/Postal Code.'));
		        $controller->getResponse()->setBody(Mage::helper('core')->jsonEncode($result));
		        return;
	        }
        }
        $validation = "/^\(*[0-9]{3}\)*\ *\-*[0-9]{3}\-*[0-9]{4}$/";
        if (!preg_match($validation, $telephone)) {
    		$controller = $observer->getControllerAction();
	        $controller->setFlag('', Mage_Core_Controller_Varien_Action::FLAG_NO_DISPATCH, true);
	        $result = array('error' => 1, 'message' => Mage::helper('checkout')->__('Please enter a valid 10 digit telephone number.'));
	        $controller->getResponse()->setBody(Mage::helper('core')->jsonEncode($result));
	        return;
        }
    }

    public function validateShippingAddress($observer)
    {
    	$data = $observer->getEvent()->getControllerAction()->getRequest()->getPost('shipping', array());
        $country_id = $data['country_id'];
        $postcode = $data['postcode'];
        $telephone = $data['telephone'];
        if ($country_id == 'US') {
        	$validation = "/^[0-9]{5}(?:-[0-9]{4})?$/";
        	if (!preg_match($validation, $postcode)) {
        		$controller = $observer->getControllerAction();
		        $controller->setFlag('', Mage_Core_Controller_Varien_Action::FLAG_NO_DISPATCH, true);
		        $result = array('error' => 1, 'message' => Mage::helper('checkout')->__('Please enter a valid Zip/Postal Code.'));
		        $controller->getResponse()->setBody(Mage::helper('core')->jsonEncode($result));
		        return;
	        }
        } else {
        	$validation = "/^[a-zA-Z0-9 ]+$/";
        	if (!preg_match($validation, $postcode)) {
        		$controller = $observer->getControllerAction();
		        $controller->setFlag('', Mage_Core_Controller_Varien_Action::FLAG_NO_DISPATCH, true);
		        $result = array('error' => 1, 'message' => Mage::helper('checkout')->__('Please use only letters (a-z or A-Z), numbers (0-9) or spaces only for Zip/Postal Code.'));
		        $controller->getResponse()->setBody(Mage::helper('core')->jsonEncode($result));
		        return;
	        }
        }
        $validation = "/^\(*[0-9]{3}\)*\ *\-*[0-9]{3}\-*[0-9]{4}$/";
        if (!preg_match($validation, $telephone)) {
    		$controller = $observer->getControllerAction();
	        $controller->setFlag('', Mage_Core_Controller_Varien_Action::FLAG_NO_DISPATCH, true);
	        $result = array('error' => 1, 'message' => Mage::helper('checkout')->__('Please enter a valid 10 digit telephone number.'));
	        $controller->getResponse()->setBody(Mage::helper('core')->jsonEncode($result));
	        return;
        }	
    }
}